<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:fn="http://www.w3.org/2004/10/xpath-functions" xmlns:xdt="http://www.w3.org/2004/10/xpath-datatypes" xmlns:cx="http://staff.aist.go.jp/i.noda/Standard/2005/CsvXml" xmlns:csvx="http://www.netconscious.co.jp/daruma/csvx" xmlns:outxsl="http://www.w3.org/1999/XSL/TransformAlias" xmlns:gml="http://www.opengis.net/gml" xmlns:rcbase="http://staff.aist.go.jp/i.noda/Rescue/RandomCity/base" xmlns:tns="__TARGETNAMESPACE__">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
	<xsl:namespace-alias stylesheet-prefix="outxsl" result-prefix="xsl"/>
	<xsl:template match="/">
		<outxsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
			<outxsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>
			<xsl:apply-templates select="cx:Config/cx:csv"/>
		</outxsl:stylesheet>
	</xsl:template>
	<xsl:template match="cx:Config/cx:csv">
		<outxsl:template match="/">
			<misp:Transaction xmlns:misp="http://www.infosharp.org/misp">
				<misp:Insert>
					<outxsl:apply-templates select="csvx:data"/>
				</misp:Insert>
			</misp:Transaction>
		</outxsl:template>
		<outxsl:template match="csvx:data">
			<outxsl:apply-templates select="csvx:row"/>
		</outxsl:template>
		<outxsl:template match="csvx:row">
			<xsl:variable name="addTnsName"><xsl:call-template name="addTns">
					<xsl:with-param name="string"><xsl:value-of select="@element"/></xsl:with-param>
			</xsl:call-template></xsl:variable>		
			<xsl:element name="{$addTnsName}">
			<xsl:call-template name="template1"/>
			</xsl:element>
			
		</outxsl:template>
		<xsl:call-template name="template2"/>
	</xsl:template>
	

	<xsl:template name="template1">
		<xsl:for-each select="./cx:columnList/cx:column">
			<xsl:variable name="attrNode">
				<xsl:value-of select="substring-after(@xpath,'@')"/>
			</xsl:variable>			
			<xsl:variable name="curNode">
				<xsl:value-of select="substring-before(@xpath,'/')"/>
			</xsl:variable>		
			<xsl:choose>
				<xsl:when test="string-length($attrNode)>0">
					<xsl:choose>
						<xsl:when test="string-length($curNode)>0">
							<outxsl:apply-templates select="csvx:column[@name='{@name}']"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:variable name="addTnsName"><xsl:call-template name="addTns">
								<xsl:with-param name="string"><xsl:value-of select="$attrNode"/></xsl:with-param>
							</xsl:call-template></xsl:variable>		
							<outxsl:attribute name="{$addTnsName}">
								<outxsl:value-of select="csvx:column[@name='{$attrNode}']"/>
							</outxsl:attribute>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<outxsl:apply-templates select="csvx:column[@name='{@name}']"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template name="template2">
		<xsl:for-each select="./cx:columnList/cx:column">
			<xsl:variable name="attrNode">
				<xsl:value-of select="substring-after(@xpath,'@')"/>
			</xsl:variable>			
			<xsl:variable name="curNode">
				<xsl:value-of select="substring-before(@xpath,'/')"/>
			</xsl:variable>	
			<xsl:choose>
				<xsl:when test="string-length($attrNode)>0">
					<xsl:if test="string-length($curNode)>0">
						<outxsl:template match="csvx:column[@name='{@name}']">
							<xsl:call-template name="createAttrTemplate">
								<xsl:with-param name="xpathString">
									<xsl:value-of select="@xpath"/>
								</xsl:with-param>
								<xsl:with-param name="csvColumnName">
									<xsl:value-of select="@name"/>
								</xsl:with-param>
							</xsl:call-template>
						</outxsl:template>
					</xsl:if>
				</xsl:when>
				<xsl:otherwise>
					<outxsl:template match="csvx:column[@name='{@name}']">
						<xsl:call-template name="createTemplate">
							<xsl:with-param name="xpathString">
								<xsl:value-of select="@xpath"/>
							</xsl:with-param>
							<xsl:with-param name="csvColumnName">
								<xsl:value-of select="@name"/>
							</xsl:with-param>
						</xsl:call-template>
					</outxsl:template>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template name="createTemplate">
		<xsl:param name="xpathString"/>
		<xsl:param name="csvColumnName"/>
		<xsl:variable name="curNode">
			<xsl:value-of select="substring-before($xpathString,'/')"/>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="string-length($curNode)>0">
				<xsl:variable name="newXpathString">
					<xsl:value-of select="substring-after($xpathString,'/')"/>
				</xsl:variable>
				<xsl:variable name="addTnsName"><xsl:call-template name="addTns">
					<xsl:with-param name="string"><xsl:value-of select="$curNode"/></xsl:with-param>
				</xsl:call-template></xsl:variable>		
				<xsl:element name="{$addTnsName}">
					<xsl:if test="string-length($newXpathString)>0">
						<xsl:call-template name="createTemplate">
							<xsl:with-param name="xpathString">
								<xsl:value-of select="$newXpathString"/>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:if>
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<xsl:variable name="addTnsName"><xsl:call-template name="addTns">
					<xsl:with-param name="string"><xsl:value-of select="$xpathString"/></xsl:with-param>
				</xsl:call-template></xsl:variable>		
				<xsl:element name="{$addTnsName}">
					<outxsl:value-of select="."/>
				</xsl:element>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="createAttrTemplate">
		<xsl:param name="xpathString"/>
		<xsl:param name="csvColumnName"/>
		<xsl:variable name="firstNode">
			<xsl:value-of select="substring-before($xpathString,'/')"/>
		</xsl:variable>
		<xsl:variable name="remainNode">
			<xsl:value-of select="substring-after($xpathString,'/')"/>
		</xsl:variable>
		<xsl:variable name="secondNode">
			<xsl:value-of select="substring-before($remainNode,'/')"/>
		</xsl:variable>
		<xsl:variable name="attrNode">
			<xsl:value-of select="substring-after($remainNode,'@')"/>
		</xsl:variable>				
		<xsl:choose>
			<xsl:when test="string-length($secondNode)>0">
				<xsl:variable name="addTnsName"><xsl:call-template name="addTns">
					<xsl:with-param name="string"><xsl:value-of select="$firstNode"/></xsl:with-param>
				</xsl:call-template></xsl:variable>		
				<xsl:element name="{$addTnsName}">
					<xsl:if test="string-length($remainNode)>0">
						<xsl:call-template name="createAttrTemplate">
							<xsl:with-param name="xpathString">
								<xsl:value-of select="$remainNode"/>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:if>
				</xsl:element>
			</xsl:when>
			<xsl:when test="string-length($firstNode)>0">
				<xsl:variable name="addTnsName"><xsl:call-template name="addTns">
					<xsl:with-param name="string"><xsl:value-of select="$firstNode"/></xsl:with-param>
				</xsl:call-template></xsl:variable>		
				<xsl:element name="{$addTnsName}">
					<xsl:variable name="addTnsName"><xsl:call-template name="addTns">
						<xsl:with-param name="string"><xsl:value-of select="$attrNode"/></xsl:with-param>
					</xsl:call-template></xsl:variable>	
					<outxsl:attribute name="{$addTnsName}">
						<outxsl:value-of select="."/>
					</outxsl:attribute>
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="addTns">
		<xsl:param name="string" select="''"/>
		<xsl:choose>
			<xsl:when test="contains($string, ':')">
				<xsl:value-of select="$string"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="concat('tns:', $string)"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
</xsl:stylesheet>
