<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:gml="http://www.opengis.net/gml" xmlns:csvx="http://www.netconscious.co.jp/daruma/csvx">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="no" omit-xml-declaration="yes"/>
	<xsl:variable name="separator">,</xsl:variable>
	<xsl:variable name="parenthesis">"</xsl:variable>
	<xsl:variable name="br" select="'&#x0a;'"/>
	<xsl:template match="csvx:data">
		<xsl:apply-templates select="csvx:row">
		</xsl:apply-templates>
	</xsl:template>
	<xsl:template match="csvx:row">
		<xsl:variable name="cnt">
			<xsl:number/>
		</xsl:variable>
		<xsl:if test="$cnt =1">
			<xsl:for-each select="csvx:column">
				<xsl:sort select="./@pos" data-type="number" order="ascending"/>
				<xsl:call-template name="csvline">
					<xsl:with-param name="header">true</xsl:with-param>
				</xsl:call-template>
			</xsl:for-each>
		</xsl:if>
		<xsl:value-of select="$br"/>
		<xsl:for-each select="csvx:column">
			<xsl:sort select="./@pos" data-type="number" order="ascending"/>
			<xsl:call-template name="csvline">
				<xsl:with-param name="header">false</xsl:with-param>
			</xsl:call-template>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="csvline">
		<xsl:param name="rowcount"/>
		<xsl:param name="header"/>
		<xsl:if test="$header='true'">
			<xsl:call-template name="header"/>
		</xsl:if>
		<xsl:if test="$header!='true'">
			<xsl:call-template name="data"/>
		</xsl:if>
	</xsl:template>
	<xsl:template name="data">
		<xsl:variable name="count">
			<xsl:number/>
		</xsl:variable>
		<xsl:if test="$count ='1'">
			<xsl:value-of select="$parenthesis"/>
			<xsl:value-of select="normalize-space(.)"/>
			<xsl:value-of select="$parenthesis"/>
		</xsl:if>
		<xsl:if test="$count!=1">
			<xsl:value-of select="$separator"/>
			<xsl:value-of select="$parenthesis"/>
			<xsl:value-of select="normalize-space(.)"/>
			<xsl:value-of select="$parenthesis"/>
		</xsl:if>
	</xsl:template>
	<xsl:template name="header">
		<xsl:variable name="count">
			<xsl:number/>
		</xsl:variable>
		<xsl:if test="$count ='1'">
			<xsl:text>#</xsl:text><xsl:value-of select="@name"/>
		</xsl:if>
		<xsl:if test="$count!=1">
			<xsl:value-of select="$separator"/>
			<xsl:value-of select="@name"/>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>
